--- libmp3lame/psymodel.c.orig	2011-05-25 05:45:55.000000000 +0900
+++ libmp3lame/psymodel.c	2011-10-30 00:49:50.000000000 +0900
@@ -1137,24 +1531,286 @@
 {
     PsyStateVar_t *const psv = &gfc->sv_psy;
     PsyConst_CB2SB_t const *const gdl = &gfc->cd_psy->l;
-    FLOAT   max[CBANDS], avg[CBANDS];
-    unsigned char mask_idx_l[CBANDS + 2];
+    FLOAT   max[CBANDS] __attribute__ ((aligned (16))), avg[CBANDS];
+    unsigned char mask_idx_l[CBANDS + 2] __attribute__ ((aligned (16)));
     int     k, b;
+#ifdef ALTIVEC
+    float tmp[4] __attribute__ ((aligned (16)));
+    const vector unsigned char v31 = (vector unsigned char)VINIT16ALL(31);
+    const vector unsigned int vmask1 = (vector unsigned int)VINIT4ALL(0xff);
+    const vector signed int vone = (vector signed int)VINIT4ALL(1);
+    const vector unsigned int vtab1 = (vector unsigned int)VINIT4(0x3f800000,0x3f4b5936,0x3f218698,0x3f218698);
+    const vector unsigned int vtab2 = (vector unsigned int)VINIT4(0x3f218698,0x3f218698,0x3f218698,0x3e809bfa);
+    const vector unsigned int vtab3 = (vector unsigned int)VINIT4(0x3df09e99,0,0,0);
+    const vector unsigned int vtable1 = (vector unsigned int)VINIT4(0x3fe39e89,0x3fec53e5,0x3ff55ea7,0x3ff9149b);
+    const vector unsigned int vtable2 = (vector unsigned int)VINIT4(0x3ffcd90e,0x3fea8f7b,0x3fd997da,0x3fbf84e2);
+    const vector unsigned int vtable3 = (vector unsigned int)VINIT4(0x3fa8917c,0x3f800000,0,0);
+    const vector float vzero = vec_xor(vzero,vzero);
+#endif
 
  /*********************************************************************
     *    Calculate the energy and the tonality of each partition.
  *********************************************************************/
     calc_energy(gdl, fftenergy, eb_l, max, avg);
     calc_mask_index_l(gfc, max, avg, mask_idx_l);
+#ifdef ALTIVEC
+    const vector unsigned char vmaskidx1 = vec_ld(0,mask_idx_l); //needs to be aligned
+    const vector unsigned char vmaskidx2 = vec_ld(16,mask_idx_l);
+    const vector unsigned char vmaskidx3 = vec_ld(32,mask_idx_l);
+    const vector unsigned char vmaskidx4 = vec_ld(48,mask_idx_l);
+    tmp[0] = gfc->sv_qnt.masking_lower;
+    vector float vmasking_lower_coeff = vec_ld(0,tmp);
+    vmasking_lower_coeff = vec_splat(vmasking_lower_coeff,0);
+#endif
 
  /*********************************************************************
     *      convolve the partitioned energy and unpredictability
     *      with the spreading function, s3_l[b][k]
  ********************************************************************/
     k = 0;
-    for (b = 0; b < gdl->npart; b++) {
+#ifdef ALTIVEC
+    for (b = 0; b < gdl->npart-3; b+=4) {
+        vector signed int v1,v2,v3,v4,v5,vkk,vkk2,vlast,vdd,vdd_n,vk,vk2;
+        vector float vf1,vf2,vf3,vf4,vecb,vx,veb,vavgmask,vmasking_lower;
+        vmasking_lower = vec_ld(0,gdl->masking_lower+b);
+        vmasking_lower = vec_madd(vmasking_lower,vmasking_lower_coeff,vzero);
+        int tmp2[4] __attribute__ ((aligned (16)));
+        int tmp3[4] __attribute__ ((aligned (16)));
+        
+        v1 = vec_ld(0,gdl->s3ind[b]); //needs to be aligned
+        v2 = vec_ld(0,gdl->s3ind[b+1]);
+        v3 = vec_ld(0,gdl->s3ind[b+2]);
+        v4 = vec_ld(0,gdl->s3ind[b+3]);
+        v1 = vec_mergeh(v1,v3);
+        v2 = vec_mergeh(v2,v4);
+        vkk = vec_mergeh(v1,v2);
+        vlast = vec_mergel(v1,v2);
+        
+        v1 = vec_sub(vlast,vkk);
+        v1 = vec_sel(v1,(vector signed int)vzero,vec_cmpgt((vector signed int)vzero,v1));
+        vec_st(v1,0,tmp2);
+        
+        tmp3[0] = k;
+        tmp3[1] = k+tmp2[0]+1;
+        tmp3[2] = k+tmp2[0]+tmp2[1]+2;
+        tmp3[3] = k+tmp2[0]+tmp2[1]+tmp2[2]+3;
+        k = k+tmp2[0]+tmp2[1]+tmp2[2]+tmp2[3]+4;
+        vk = vec_ld(0,tmp3);
+        
+        v1 = (vector signed int)vec_perm(vmaskidx1,vmaskidx2,(vector unsigned char)vkk);
+        v2 = (vector signed int)vec_perm(vmaskidx3,vmaskidx4,(vector unsigned char)vkk);
+        vdd = vec_sel(v1,v2,vec_cmpgt(vkk,(vector signed int)VINIT4ALL(31)));
+        vdd = vec_and(vdd,(vector signed int)vmask1);
+        vdd_n = vone;
+        
+        tmp[0] = gdl->s3[tmp3[0]];
+        tmp[1] = gdl->s3[tmp3[1]];
+        tmp[2] = gdl->s3[tmp3[2]];
+        tmp[3] = gdl->s3[tmp3[3]];
+        vf1 = vec_ld(0,tmp);
+        
+        vec_st(vkk,0,tmp2);
+        tmp[0] = eb_l[tmp2[0]];
+        tmp[1] = eb_l[tmp2[1]];
+        tmp[2] = eb_l[tmp2[2]];
+        tmp[3] = eb_l[tmp2[3]];
+        veb = vec_ld(0,tmp);
+        
+        vecb = vec_madd(vf1,veb,vzero);
+        
+        v1 = vec_sl(vdd,vec_splat_u32(2));
+        v2 = vec_add(v1,vec_splat_s32(1));
+        v3 = vec_add(v1,vec_splat_s32(2));
+        v4 = vec_add(v2,vec_splat_s32(2));
+        v1 = vec_sl(v1,vec_splat_u32(-8));
+        v2 = vec_sl(v2,vec_splat_u32(-16));
+        v3 = vec_sl(v3,vec_splat_u32(8));
+        v1 = vec_or(v1,v2);
+        v3 = vec_or(v3,v4);
+        v1 = vec_or(v1,v3);
+        
+        vf1 = (vector float)vec_perm(vtab1,vtab2,(vector unsigned char)v1);
+        vf2 = (vector float)vec_perm(vtab3,vtab2,(vector unsigned char)v1);
+        vf2 = vec_sel(vf1,vf2,(vector unsigned int)vec_cmpgt((vector unsigned char)v1,v31));
+        vecb = vec_madd(vecb,vf2,vzero);
+        
+        vkk = vec_add(vkk,vone);
+        vk = vec_add(vk,vone);
+        while(vec_any_le(vkk,vlast)) {
+            vkk2 = vec_sel(vkk,vlast,vec_cmpgt(vkk,vlast));
+            vk2 = vec_sel(vk,(vector signed int)vzero,vec_cmpgt(vkk,vlast));
+            v1 = (vector signed int)vec_perm(vmaskidx1,vmaskidx2,(vector unsigned char)vkk2);
+            v2 = (vector signed int)vec_perm(vmaskidx3,vmaskidx4,(vector unsigned char)vkk2);
+            v1 = vec_sel(v1,v2,vec_cmpgt(vkk2,(vector signed int)VINIT4ALL(31)));
+            v1 = vec_and(v1,(vector signed int)vmask1);
+            v2 = (vector signed int)vec_cmpgt(vkk,vlast);
+            v2 = vec_nor(v2,v2);
+            v5 = vec_and(v1,v2);
+            v2 = vec_and(vone,v2);
+            vdd = vec_add(vdd,v5);
+            vdd_n = vec_add(vdd_n,v2);
+            
+            vec_st(vk2,0,tmp2);
+            tmp[0] = gdl->s3[tmp2[0]];
+            tmp[1] = gdl->s3[tmp2[1]];
+            tmp[2] = gdl->s3[tmp2[2]];
+            tmp[3] = gdl->s3[tmp2[3]];
+            vf1 = vec_ld(0,tmp);
+            
+            vec_st(vkk,0,tmp2);
+            tmp[0] = eb_l[tmp2[0]];
+            tmp[1] = eb_l[tmp2[1]];
+            tmp[2] = eb_l[tmp2[2]];
+            tmp[3] = eb_l[tmp2[3]];
+            veb = vec_ld(0,tmp);
+            
+            vx = vec_madd(vf1,veb,vzero);
+            
+            v1 = vec_sl(v5,vec_splat_u32(2));
+            v2 = vec_add(v1,vec_splat_s32(1));
+            v3 = vec_add(v1,vec_splat_s32(2));
+            v4 = vec_add(v2,vec_splat_s32(2));
+            v1 = vec_sl(v1,vec_splat_u32(-8));
+            v2 = vec_sl(v2,vec_splat_u32(-16));
+            v3 = vec_sl(v3,vec_splat_u32(8));
+            v1 = vec_or(v1,v2);
+            v3 = vec_or(v3,v4);
+            v1 = vec_or(v1,v3);
+            
+            vf1 = (vector float)vec_perm(vtab1,vtab2,(vector unsigned char)v1);
+            vf2 = (vector float)vec_perm(vtab3,vtab2,(vector unsigned char)v1);
+            vf2 = vec_sel(vf1,vf2,(vector unsigned int)vec_cmpgt((vector unsigned char)v1,v31));
+            vx = vec_madd(vx,vf2,vzero);
+            {
+                vector float vratio,vout,vf5;
+                vf1 = vec_sel(vecb,vzero,vec_cmplt(vecb,vzero));
+                vf2 = vec_sel(vx,vzero,vec_cmplt(vx,vzero));
+                vf3 = vec_sel(vf1,vf2,vec_cmpgt(vf2,vf1));
+                vf4 = vec_sel(vf2,vf1,vec_cmpgt(vf2,vf1));
+                vf5 = vec_re(vf4);
+                vratio = vec_madd(vf3,vec_madd(vec_nmsub(vf4,vf5,(vector float)VINIT4ALL(1.0)),vf5,vf5),vzero);
+                
+                tmp2[0] = b;
+                tmp2[1] = b+1;
+                tmp2[2] = b+2;
+                tmp2[3] = b+3;
+                tmp3[0] = mask_add_delta(mask_idx_l[b]);
+                tmp3[1] = mask_add_delta(mask_idx_l[b+1]);
+                tmp3[2] = mask_add_delta(mask_idx_l[b+2]);
+                tmp3[3] = mask_add_delta(mask_idx_l[b+3]);
+                v1 = vec_ld(0,tmp2);
+                v1 = vec_sub(vkk2,v1);
+                v2 = vec_ld(0,tmp3);
+                v1 = vec_abs(v1);
+                v5 = (vector signed int)vec_cmpgt(v1,v2);
+                v3 = (vector signed int)vec_cmpge(vratio,vmamax1);
+                
+                vf4 = vec_add(vf1,vf2);
+                if(vec_any_eq(vec_or(v5,v3),(vector signed int)vzero)) {
+                    vf3 = fast_log10_altivec_2(vratio);
+                    v1 = vec_cts(vf3,4);
+                    v1 = vec_sl(v1,vec_splat_u32(2));
+                    v2 = vec_add(v1,vec_splat_s32(1));
+                    v3 = vec_add(v1,vec_splat_s32(2));
+                    v4 = vec_add(v2,vec_splat_s32(2));
+                    v1 = vec_sl(v1,vec_splat_u32(-8));
+                    v2 = vec_sl(v2,vec_splat_u32(-16));
+                    v3 = vec_sl(v3,vec_splat_u32(8));
+                    v1 = vec_or(v1,v2);
+                    v3 = vec_or(v3,v4);
+                    v1 = vec_or(v1,v3);
+                    vf3 = (vector float)vec_perm(vtable1,vtable2,(vector unsigned char)v1);
+                    vf5 = (vector float)vec_perm(vtable3,vtable2,(vector unsigned char)v1);
+                    vf5 = vec_sel(vf3,vf5,(vector unsigned int)vec_cmpgt((vector unsigned char)v1,v31));
+                    vf5 = vec_madd(vf4,vf5,vzero);
+                    vf5 = vec_sel(vf5,vf4,vec_cmpge(vratio,vmamax1));
+                }
+                else vf5 = vf4;
+                
+                vout = vec_sel(vf1,vf2,vec_cmpgt(vf2,vf1));
+                vout = vec_sel(vout,vf4,vec_cmpgt(vmamax2,vratio));
+                vout = vec_sel(vf5,vout,(vector unsigned int)v5);
+                vout = vec_sel(vout,vecb,(vector unsigned int)vec_cmple(vx,vzero));
+                vout = vec_sel(vout,vx,(vector unsigned int)vec_cmple(vecb,vzero));
+                vecb = vec_sel(vout,vecb,vec_cmpgt(vkk,vlast));
+            }
+            vkk = vec_add(vkk,vone);
+            vk = vec_add(vk,vone);
+        }
+        vdd = vec_sl(vdd,(vector unsigned int)vone);
+        vdd_n = vec_sl(vdd_n,(vector unsigned int)vone);
+        vdd = vec_add(vdd,vone);
+        vf1 = vec_ctf(vdd,0);
+        vf2 = vec_ctf(vdd_n,0);
+        vf2 = vec_re(vf2);
+        vf1 = vec_madd(vf1,vf2,vzero);
+        vdd = vec_cts(vf1,0);
+        
+        v1 = vec_sl(vdd,vec_splat_u32(2));
+        v2 = vec_add(v1,vec_splat_s32(1));
+        v3 = vec_add(v1,vec_splat_s32(2));
+        v4 = vec_add(v2,vec_splat_s32(2));
+        v1 = vec_sl(v1,vec_splat_u32(-8));
+        v2 = vec_sl(v2,vec_splat_u32(-16));
+        v3 = vec_sl(v3,vec_splat_u32(8));
+        v1 = vec_or(v1,v2);
+        v3 = vec_or(v3,v4);
+        v1 = vec_or(v1,v3);
+        
+        vf1 = (vector float)vec_perm(vtab1,vtab2,(vector unsigned char)v1);
+        vf2 = (vector float)vec_perm(vtab3,vtab2,(vector unsigned char)v1);
+        vf1 = vec_sel(vf1,vf2,(vector unsigned int)vec_cmpgt((vector unsigned char)v1,v31));
+        vf2 = vec_ctf(vone,1);
+        vavgmask = vec_madd(vf1,vf2,vzero);
+        vecb = vec_madd(vecb,vavgmask,vzero);
+        
+        vf4 = vec_ld(0,eb_l+b); //needs to be aligned
+        if (psv->blocktype_old[chn & 0x01] == SHORT_TYPE) {
+            vf1 = vec_ld(0,psv->nb_l1[chn]+b); //needs to be aligned
+            vf3 = vec_madd(vf1,(vector float)VINIT4ALL(rpelev),vzero);
+            vf2 = vec_madd(vf4,(vector float)VINIT4ALL(NS_PREECHO_ATT2),vzero);
+            vf3 = vec_sel(vf2,vf3,vec_cmpgt(vf3,vzero));
+            vf3 = vec_min(vecb,vf3);
+            //vec_st(vf3,0,thr+b); //needs to be aligned
+        }
+        else {
+            vf1 = vec_ld(0,psv->nb_l1[chn]+b); //needs to be aligned
+            vf2 = vec_ld(0,psv->nb_l2[chn]+b); //needs to be aligned
+            vf3 = vec_madd(vf1,(vector float)VINIT4ALL(rpelev),vzero);
+            vf2 = vec_madd(vf2,(vector float)VINIT4ALL(rpelev2),vzero);
+            vf3 = vec_sel(vzero,vf3,vec_cmpgt(vf3,vzero));
+            vf2 = vec_sel(vzero,vf2,vec_cmpgt(vf2,vzero));
+            if (psv->blocktype_old[chn & 0x01] == NORM_TYPE) {
+                vf3 = vec_min(vf3,vf2);
+            }
+            vf3 = vec_min(vecb,vf3);
+            //vec_st(vf3,0,thr+b); //needs to be aligned
+        }
+        vec_st(vf1,0,psv->nb_l2[chn]+b); //needs to be aligned
+        vec_st(vecb,0,psv->nb_l1[chn]+b); //needs to be aligned
+        {
+            vx = vec_ld(0,max+b); //needs to be aligned
+            vf1 = vec_ld(0,gdl->minval+b);
+            vx = vec_madd(vx,vf1,vzero);
+            vx = vec_madd(vx,vavgmask,vzero);
+            vf3 = vec_sel(vf3,vx,vec_cmpgt(vf3,vx));
+            //vec_st(vf3,0,thr+b); //needs to be aligned
+        }
+		v1 = (vector signed int)vec_cmpgt(vmasking_lower,(vector float)VINIT4ALL(1.0f));
+		vf1 = vec_madd(vf3,vmasking_lower,vzero);
+		vf3 = vec_sel(vf3,vf1,v1);
+        vf3 = vec_sel(vf3,vf4,vec_cmpgt(vf3,vf4));
+		vf1 = vec_madd(vf3,vmasking_lower,vzero);
+		vf3 = vec_sel(vf1,vf3,v1);
+        vec_st(vf3,0,thr+b); //needs to be aligned
+    }
+#else
+    b=0;
+#endif
+    for (; b < gdl->npart; b++) {
         FLOAT   x, ecb, avg_mask, t;
         FLOAT const masking_lower = gdl->masking_lower[b] * gfc->sv_qnt.masking_lower;
+		//fprintf(stderr,"%f\n",masking_lower);
         /* convolve the partitioned energy with the spreading function */
         int     kk = gdl->s3ind[b][0];
         int const last = gdl->s3ind[b][1];
@@ -1413,11 +2069,11 @@
     /* fft and energy calculation   */
     FLOAT(*wsamp_l)[BLKSIZE];
     FLOAT(*wsamp_s)[3][BLKSIZE_s];
-    FLOAT   fftenergy[HBLKSIZE];
-    FLOAT   fftenergy_s[3][HBLKSIZE_s];
-    FLOAT   wsamp_L[2][BLKSIZE];
-    FLOAT   wsamp_S[2][3][BLKSIZE_s];
-    FLOAT   eb[4][CBANDS], thr[4][CBANDS];
+    FLOAT   fftenergy[HBLKSIZE] __attribute__ ((aligned (16)));
+    FLOAT   fftenergy_s[3][HBLKSIZE_s+3] __attribute__ ((aligned (16)));
+    FLOAT   wsamp_L[2][BLKSIZE] __attribute__ ((aligned (16)));
+    FLOAT   wsamp_S[2][3][BLKSIZE_s] __attribute__ ((aligned (16)));
+    FLOAT   eb[4][CBANDS] __attribute__ ((aligned (16))), thr[4][CBANDS] __attribute__ ((aligned (16)));
 
     FLOAT   sub_short_factor[4][3];
     FLOAT   thmm;
@@ -1426,7 +2082,7 @@
         (cfg->msfix > 0.f) ? (cfg->ATH_offset_factor * gfc->ATH->adjust_factor) : 1.f;
 
     const   FLOAT(*const_eb)[CBANDS] = (const FLOAT(*)[CBANDS]) eb;
-    const   FLOAT(*const_fftenergy_s)[HBLKSIZE_s] = (const FLOAT(*)[HBLKSIZE_s]) fftenergy_s;
+    const   FLOAT(*const_fftenergy_s)[HBLKSIZE_s+3] = (const FLOAT(*)[HBLKSIZE_s+3]) fftenergy_s;
 
     /* block type  */
     int     ns_attacks[4][4] = { {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0} };
@@ -1814,7 +2470,7 @@
 }
 
 static int
-init_s3_values(FLOAT ** p, int (*s3ind)[2], int npart,
+init_s3_values(FLOAT ** p, int (*s3ind)[4], int npart,
                FLOAT const *bval, FLOAT const *bval_width, FLOAT const *norm)
 {
     FLOAT   s3[CBANDS][CBANDS];
--- libmp3lame/quantize.c.orig	2012-01-10 19:08:47.000000000 +0900
+++ libmp3lame/quantize.c	2012-01-10 20:26:53.000000000 +0900
@@ -28,6 +28,12 @@
 # include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
+
 #include "lame.h"
 #include "machine.h"
 #include "encoder.h"
@@ -42,7 +48,26 @@
 #endif
 
 
-
+#ifdef PPC_FRSQRTE
+static inline double __frsqrte(double number)
+{
+    double y;
+    asm("frsqrte %0,%1" : "=f" (y) : "f" (number));
+    return y;
+}
+
+static inline double ppc_sqrt(double x) {
+    double y;
+    const double halfx = 0.5 * x;
+    y = __frsqrte(x);
+    y *= 1.5 - halfx * y * y;
+    y *= 1.5 - halfx * y * y;
+    y *= 1.5 - halfx * y * y;
+    //y *= 1.5 - halfx * y * y;
+    y *= x;
+    return (x == 0.0) ? 0 : y;
+}
+#endif
 
 /* convert from L/R <-> Mid/Side */
 static void
@@ -72,9 +97,162 @@
 static void
 init_xrpow_core_c(gr_info * const cod_info, FLOAT xrpow[576], int upper, FLOAT * sum)
 {
+#ifdef ALTIVEC
+    vector float v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,v17,v18,v19,v20;
+    vector float vsum,vsum2,vsum3,vsum4,vmax,vmax2,vmax3,vmax4,vzero;
+    vector unsigned char vc1,vc2,vc3,vc4,vc5,vperm;
+    vector float vconst1 = (vector float)VINIT4ALL(0.25);
+    vector float vconst2 = (vector float)VINIT4ALL(1.25);
+#endif
     int     i;
     FLOAT   tmp;
     *sum = 0;
+#ifdef ALTIVEC
+    vc1 = vec_splat_u8(1);
+    vc2 = vec_splat_u8(5);
+    vc3 = vec_sl(vc1,vc2);
+    vc4 = vec_sl(vc3,vc1);
+    vc5 = vec_or(vc3,vc4);
+    vsum = vec_xor(vsum,vsum);
+    vzero = vec_xor(vzero,vzero);
+    vmax = vec_xor(vmax,vmax);
+    vsum2 = vec_xor(vsum2,vsum2);
+    vmax2 = vec_xor(vmax2,vmax2);
+    vsum3 = vec_xor(vsum3,vsum3);
+    vmax3 = vec_xor(vmax3,vmax3);
+    vsum4 = vec_xor(vsum4,vsum4);
+    vmax4 = vec_xor(vmax4,vmax4);
+    
+    v0 = vec_ld(0,(cod_info->xr));
+    vperm = vec_lvsl(0,(cod_info->xr));
+    for (i = 0; i <= upper-15; i+=16) {
+        v1 = vec_ld(16,(cod_info->xr)+i);
+        v2 = vec_ld(32,(cod_info->xr)+i);
+        v3 = vec_ld(48,(cod_info->xr)+i);
+        v4 = vec_ld(64,(cod_info->xr)+i);
+        v5 = vec_perm(v0,v1,vperm);
+        v6 = vec_perm(v1,v2,vperm);
+        v7 = vec_perm(v2,v3,vperm);
+        v8 = vec_perm(v3,v4,vperm);
+        v0 = v4;
+        v9 = vec_abs(v5);
+        v10 = vec_abs(v6);
+        v11 = vec_abs(v7);
+        v12 = vec_abs(v8);
+        vsum = vec_add(vsum,v9);
+        vsum2 = vec_add(vsum2,v10);
+        vsum3 = vec_add(vsum3,v11);
+        vsum4 = vec_add(vsum4,v12);
+        v1 = vec_re(vec_rsqrte(vec_rsqrte(v9)));
+        v2 = vec_re(vec_rsqrte(vec_rsqrte(v10)));
+        v3 = vec_re(vec_rsqrte(vec_rsqrte(v11)));
+        v4 = vec_re(vec_rsqrte(vec_rsqrte(v12)));
+        v5 = (vector float)vec_cmpeq(vzero,v9);
+        v6 = (vector float)vec_cmpeq(vzero,v10);
+        v7 = (vector float)vec_cmpeq(vzero,v11);
+        v8 = (vector float)vec_cmpeq(vzero,v12);
+        v13 = vec_madd(v1,v1,vzero);
+        v14 = vec_madd(v2,v2,vzero);
+        v15 = vec_madd(v3,v3,vzero);
+        v16 = vec_madd(v4,v4,vzero);
+        v13 = vec_madd(v13,v13,vzero);
+        v14 = vec_madd(v14,v14,vzero);
+        v15 = vec_madd(v15,v15,vzero);
+        v16 = vec_madd(v16,v16,vzero);
+        v17 = vec_madd(v9,vconst1,vzero);
+        v18 = vec_madd(v10,vconst1,vzero);
+        v19 = vec_madd(v11,vconst1,vzero);
+        v20 = vec_madd(v12,vconst1,vzero);
+        v13 = vec_nmsub(v13,v17,vconst2);
+        v14 = vec_nmsub(v14,v18,vconst2);
+        v15 = vec_nmsub(v15,v19,vconst2);
+        v16 = vec_nmsub(v16,v20,vconst2);
+        v1 = vec_madd(v13,v1,vzero);
+        v2 = vec_madd(v14,v2,vzero);
+        v3 = vec_madd(v15,v3,vzero);
+        v4 = vec_madd(v16,v4,vzero);
+        v1 = vec_sel(v1,vzero,(vector unsigned int)v5);
+        v2 = vec_sel(v2,vzero,(vector unsigned int)v6);
+        v3 = vec_sel(v3,vzero,(vector unsigned int)v7);
+        v4 = vec_sel(v4,vzero,(vector unsigned int)v8);
+        v17 = vec_madd(v1,v9,vzero);
+        v18 = vec_madd(v2,v10,vzero);
+        v19 = vec_madd(v3,v11,vzero);
+        v20 = vec_madd(v4,v12,vzero);
+        vec_st(v17,0,xrpow+i);
+        vec_st(v18,16,xrpow+i);
+        vec_st(v19,32,xrpow+i);
+        vec_st(v20,48,xrpow+i);
+        vmax = vec_max(v17,vmax);
+        vmax2 = vec_max(v18,vmax2);
+        vmax3 = vec_max(v19,vmax3);
+        vmax4 = vec_max(v20,vmax4);
+    }
+    vmax = vec_max(vmax,vmax2);
+    vmax3 = vec_max(vmax3,vmax4);
+    vmax = vec_max(vmax,vmax3);
+    vsum = vec_add(vsum,vsum2);
+    vsum3 = vec_add(vsum3,vsum4);
+    vsum = vec_add(vsum,vsum3);
+    v1 = vec_slo(vmax,vc3);
+    v2 = vec_slo(vsum,vc3);
+    v3 = vec_max(v1,vmax);
+    v4 = vec_add(v2,vsum);
+    v5 = vec_slo(v3,vc4);
+    v6 = vec_slo(v4,vc4);
+    vmax = vec_max(v3,v5);
+    vsum = vec_add(v4,v6);
+    vmax = vec_perm(vmax,vmax,vec_lvsr(0,&(cod_info->xrpow_max)));
+    vsum = vec_perm(vsum,vsum,vec_lvsr(0,sum));
+    vec_ste(vmax,0,&(cod_info->xrpow_max));
+    vec_ste(vsum,0,sum);
+    
+    for (; i <= upper; i++) {
+        tmp = fabs(cod_info->xr[i]);
+        *sum += tmp;
+        xrpow[i] = sqrt(tmp * sqrt(tmp));
+        
+        if (xrpow[i] > cod_info->xrpow_max)
+        cod_info->xrpow_max = xrpow[i];
+    }
+#else
+#ifdef PPC_FRSQRTE
+    FLOAT   tmp2,tmp3,tmp4;
+    
+    for (i = 0; i <= upper-3; i+=4) {
+        tmp = fabs (cod_info->xr[i]);
+        tmp2 = fabs (cod_info->xr[i+1]);
+        tmp3 = fabs (cod_info->xr[i+2]);
+        tmp4 = fabs (cod_info->xr[i+3]);
+        *sum += tmp;
+        *sum += tmp2;
+        *sum += tmp3;
+        *sum += tmp4;
+        
+        xrpow[i] = ppc_sqrt (tmp * ppc_sqrt(tmp));
+        xrpow[i+1] = ppc_sqrt (tmp2 * ppc_sqrt(tmp2));
+        xrpow[i+2] = ppc_sqrt (tmp3 * ppc_sqrt(tmp3));
+        xrpow[i+3] = ppc_sqrt (tmp4 * ppc_sqrt(tmp4));
+        
+        if (xrpow[i] > cod_info->xrpow_max)
+        cod_info->xrpow_max = xrpow[i];
+        if (xrpow[i+1] > cod_info->xrpow_max)
+        cod_info->xrpow_max = xrpow[i+1];
+        if (xrpow[i+2] > cod_info->xrpow_max)
+        cod_info->xrpow_max = xrpow[i+2];
+        if (xrpow[i+3] > cod_info->xrpow_max)
+        cod_info->xrpow_max = xrpow[i+3];
+    }
+    
+    for (; i <= upper; i++) {
+        tmp = fabs(cod_info->xr[i]);
+        *sum += tmp;
+        xrpow[i] = ppc_sqrt(tmp * ppc_sqrt(tmp));
+
+        if (xrpow[i] > cod_info->xrpow_max)
+            cod_info->xrpow_max = xrpow[i];
+    }
+#else
     for (i = 0; i <= upper; ++i) {
         tmp = fabs(cod_info->xr[i]);
         *sum += tmp;
@@ -83,6 +261,8 @@
         if (xrpow[i] > cod_info->xrpow_max)
             cod_info->xrpow_max = xrpow[i];
     }
+#endif
+#endif
 }
 
 
@@ -1495,7 +1675,7 @@
     EncResult_t *const eov = &gfc->ov_enc;
     FLOAT   l3_xmin[2][2][SFBMAX];
 
-    FLOAT   xrpow[576];
+    FLOAT   xrpow[576] __attribute__ ((aligned (16)));
     int     bands[2][2];
     int     frameBits[15];
     int     used_bits;
@@ -1650,7 +1830,7 @@
     EncResult_t *const eov = &gfc->ov_enc;
     FLOAT   l3_xmin[2][2][SFBMAX];
 
-    FLOAT   xrpow[2][2][576];
+    FLOAT   xrpow[2][2][576] __attribute__ ((aligned (16)));
     int     frameBits[15];
     int     used_bits;
     int     max_bits[2][2];
@@ -1904,7 +2084,7 @@
     SessionConfig_t const *const cfg = &gfc->cfg;
     EncResult_t *const eov = &gfc->ov_enc;
     FLOAT   l3_xmin[SFBMAX];
-    FLOAT   xrpow[576];
+    FLOAT   xrpow[576] __attribute__ ((aligned (16)));
     int     targ_bits[2][2];
     int     mean_bits, max_frame_bits;
     int     ch, gr, ath_over;
@@ -1991,7 +2171,7 @@
 {
     SessionConfig_t const *const cfg = &gfc->cfg;
     FLOAT   l3_xmin[SFBMAX];
-    FLOAT   xrpow[576];
+    FLOAT   xrpow[576] __attribute__ ((aligned (16)));
     int     targ_bits[2];
     int     mean_bits, max_bits;
     int     gr, ch;
--- libmp3lame/quantize_pvt.c.orig	2012-02-08 03:15:00.000000000 +0900
+++ libmp3lame/quantize_pvt.c	2012-02-08 17:32:36.000000000 +0900
@@ -27,6 +27,13 @@
 # include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#undef TAKEHIRO_IEEE754_HACK
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
+
 
 #include "lame.h"
 #include "machine.h"
@@ -750,6 +757,39 @@
 static  FLOAT
 calc_noise_core_c(const gr_info * const cod_info, int *startline, int l, FLOAT step)
 {
+#ifdef ALTIVEC
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,v9,va,vb,vstep,vzero,vnoise1,vnoise2,vix01;
+    vector unsigned char vperm1,vperm2,vperm5,vperm6;
+    vector signed int vx1,vx2,vx3,vx4,vx5,vx6,vx7,vshamt,vone;
+#ifdef ALTIVEC_970
+    vector unsigned int vmask1,vmask2,vmask3;
+    vector float v10,v11,v12,v13,v14,v15,v16,v17;
+#else
+    vector unsigned char vc1,vc2,vc3,vc4,vc5,vc6,vperm3,vperm4,vmask;
+#endif
+    float temp[4] __attribute__ ((aligned (16)));
+    
+    temp[0] = step;
+    vstep = vec_ld(0,temp);
+    vzero = vec_xor(vzero,vzero);
+    vperm6 = (vector unsigned char)VINIT16(0,0,3,19,0,0,7,23,0,0,11,27,0,0,15,31);
+    vperm5 = vec_sld(vperm6,vperm6,2);
+#ifdef ALTIVEC_970
+    vmask1 = vec_splat_u32(-1);
+    vmask2 = vec_sld((vector unsigned int)vzero,vmask1,8);
+    vmask3 = vec_sld((vector unsigned int)vzero,vmask1,4);
+    vmask1 = vec_sld((vector unsigned int)vzero,vmask1,12);
+#else
+    vperm3 = (vector unsigned char)VINIT16(0,0,0,0,0,0,0,0,0,1,2,3,16,17,18,19);
+    vperm4 = vec_sld(vperm3,(vector unsigned char)vzero,8);
+    vmask = (vector unsigned char)VINIT16ALL(16);
+#endif
+    vstep = vec_splat(vstep,0);
+    vnoise1 = vec_xor(vnoise1,vnoise1);
+    vnoise2 = vec_xor(vnoise2,vnoise2);
+    vone = vec_splat_s32(1);
+    vshamt = vec_splat_s32(2);
+#endif
     FLOAT   noise = 0;
     int     j = *startline;
     const int *const ix = cod_info->l3_enc;
@@ -766,9 +806,55 @@
         }
     }
     else if (j > cod_info->big_values) {
-        FLOAT   ix01[2];
+        FLOAT   ix01[4] __attribute__ ((aligned (16)));
         ix01[0] = 0;
         ix01[1] = step;
+#ifdef ALTIVEC
+        vix01 = vec_ld(0,ix01);
+        v1 = vec_ld(0,cod_info->xr+j);
+        vperm1 = vec_lvsl(0,cod_info->xr+j);
+        vx1 = vec_ld(0,ix+j);
+        vperm2 = vec_lvsl(0,ix+j);
+        for(;l>1;l-=2) {
+            v2 = vec_ld(16,cod_info->xr+j);
+            vx2 = vec_ld(16,ix+j);
+            v3 = vec_perm(v1,v2,vperm1);
+            vx3 = vec_perm(vx1,vx2,vperm2);
+            va = vec_abs(v3);
+            v1 = v2;
+            vx1 = vx2;
+            
+            vx4 = vec_sl(vx3,(vector unsigned int)vshamt);
+            vx5 = vec_add(vx4,vone);
+            vx6 = vec_add(vx4,vshamt);
+            vx7 = vec_add(vx5,vshamt);
+            vx2 = vec_perm(vx4,vx5,vperm5);
+            vx3 = vec_perm(vx6,vx7,vperm6);
+            vx4 = vec_or(vx2,vx3);
+            
+            v2 = vec_perm(vix01,vix01,(vector unsigned char)vx4);
+            va = vec_sub(va,v2);
+            
+            vnoise1 = vec_madd(va,va,vnoise1);
+            
+            j += 4;
+        }
+        v1 = vec_sld(vnoise1,vnoise1,8);
+        v2 = vec_add(vnoise1,v1);
+        v3 = vec_sld(v2,v2,4);
+        v4 = vec_add(v2,v3);
+        v5 = vec_perm(v4,v4,vec_lvsr(0,&noise));
+        vec_ste(v5,0,&noise);
+		if(l) {
+            FLOAT   temp;
+            temp = fabs(cod_info->xr[j]) - ix01[ix[j]];
+            j++;
+            noise += temp * temp;
+            temp = fabs(cod_info->xr[j]) - ix01[ix[j]];
+            j++;
+            noise += temp * temp;
+        }
+#else
         while (l--) {
             FLOAT   temp;
             temp = fabs(cod_info->xr[j]) - ix01[ix[j]];
@@ -778,8 +864,138 @@
             j++;
             noise += temp * temp;
         }
+#endif
     }
     else {
+#ifdef ALTIVEC
+        vperm1 = vec_lvsl(0,cod_info->xr+j);
+        v1 = vec_ld(0,cod_info->xr+j);
+        for(;l>3;l-=4) {
+            v2 = vec_ld(16,cod_info->xr+j);
+            v3 = vec_ld(32,cod_info->xr+j);
+            v4 = vec_perm(v1,v2,vperm1);
+            v5 = vec_perm(v2,v3,vperm1);
+            va = vec_abs(v4);
+            vb = vec_abs(v5);
+            v1 = v3;
+            
+#ifdef ALTIVEC_970
+            v2 = vec_lde(0,pow43+ix[j]);
+            v6 = vec_lde(0,pow43+ix[j+1]);
+            v10 = vec_lde(0,pow43+ix[j+2]);
+            v14 = vec_lde(0,pow43+ix[j+3]);
+            v4 = vec_perm(v2,v2,vec_lvsl(0,pow43+ix[j]));
+            v8 = vec_perm(v6,v6,vec_lvsl(-4,pow43+ix[j+1]));
+            v12 = vec_perm(v10,v10,vec_lvsl(-8,pow43+ix[j+2]));
+            v16 = vec_perm(v14,v14,vec_lvsl(-12,pow43+ix[j+3]));
+            v4 = vec_sel(v4,v8,vmask1);
+            v4 = vec_sel(v4,v12,vmask2);
+            v4 = vec_sel(v4,v16,vmask3);
+            va = vec_nmsub(v4,vstep,va);
+#else
+            vc1 = vec_lvsl(0,pow43+ix[j]);
+            vc2 = vec_lvsl(0,pow43+ix[j+1]);
+            vc3 = vec_lvsl(0,pow43+ix[j+2]);
+            vc4 = vec_lvsl(0,pow43+ix[j+3]);
+            vc2 = vec_or(vc2,vmask);
+            vc4 = vec_or(vc4,vmask);
+            v2 = vec_lde(0,pow43+ix[j]);
+            v3 = vec_lde(0,pow43+ix[j+1]);
+            v4 = vec_lde(0,pow43+ix[j+2]);
+            v5 = vec_lde(0,pow43+ix[j+3]);
+            vc5 = vec_perm(vc1,vc2,vperm3);
+            vc6 = vec_perm(vc3,vc4,vperm4);
+            v6 = vec_perm(v2,v3,vc5);
+            v7 = vec_perm(v4,v5,vc6);
+            v8 = vec_sld(v6,v7,8);
+            va = vec_nmsub(v8,vstep,va);
+#endif
+            j+=4;
+            
+#ifdef ALTIVEC_970
+            v3 = vec_lde(0,pow43+ix[j]);
+            v7 = vec_lde(0,pow43+ix[j+1]);
+            v11 = vec_lde(0,pow43+ix[j+2]);
+            v15 = vec_lde(0,pow43+ix[j+3]);
+            v5 = vec_perm(v3,v3,vec_lvsl(0,pow43+ix[j]));
+            v9 = vec_perm(v7,v7,vec_lvsl(-4,pow43+ix[j+1]));
+            v13 = vec_perm(v11,v11,vec_lvsl(-8,pow43+ix[j+2]));
+            v17 = vec_perm(v15,v15,vec_lvsl(-12,pow43+ix[j+3]));
+            v5 = vec_sel(v5,v9,vmask1);
+            v5 = vec_sel(v5,v13,vmask2);
+            v5 = vec_sel(v5,v17,vmask3);
+            vb = vec_nmsub(v5,vstep,vb);
+#else
+            vc1 = vec_lvsl(0,pow43+ix[j]);
+            vc2 = vec_lvsl(0,pow43+ix[j+1]);
+            vc3 = vec_lvsl(0,pow43+ix[j+2]);
+            vc4 = vec_lvsl(0,pow43+ix[j+3]);
+            vc2 = vec_or(vc2,vmask);
+            vc4 = vec_or(vc4,vmask);
+            v2 = vec_lde(0,pow43+ix[j]);
+            v3 = vec_lde(0,pow43+ix[j+1]);
+            v4 = vec_lde(0,pow43+ix[j+2]);
+            v5 = vec_lde(0,pow43+ix[j+3]);
+            vc5 = vec_perm(vc1,vc2,vperm3);
+            vc6 = vec_perm(vc3,vc4,vperm4);
+            v6 = vec_perm(v2,v3,vc5);
+            v7 = vec_perm(v4,v5,vc6);
+            v8 = vec_sld(v6,v7,8);
+            vb = vec_nmsub(v8,vstep,vb);
+#endif
+            
+            vnoise1 = vec_madd(va,va,vnoise1);
+            vnoise2 = vec_madd(vb,vb,vnoise2);
+            
+            j+=4;
+        }
+        vnoise1 = vec_add(vnoise1,vnoise2);
+        
+        for(;l>1;l-=2) {
+            v2 = vec_ld(16,cod_info->xr+j);
+            v4 = vec_perm(v1,v2,vperm1);
+            va = vec_abs(v4);
+            v1 = v2;
+            
+            v2 = vec_lde(0,pow43+ix[j]);
+            v3 = vec_lde(0,pow43+ix[j+1]);
+            v4 = vec_lde(0,pow43+ix[j+2]);
+            v5 = vec_lde(0,pow43+ix[j+3]);
+            v6 = vec_perm(v2,v2,vec_lvsl(0,pow43+ix[j]));
+            v7 = vec_perm(v3,v3,vec_lvsl(-4,pow43+ix[j+1]));
+            v8 = vec_perm(v4,v4,vec_lvsl(-8,pow43+ix[j+2]));
+            v9 = vec_perm(v5,v5,vec_lvsl(-12,pow43+ix[j+3]));
+#ifdef ALTIVEC_970
+            v6 = vec_sel(v6,v7,vmask1);
+            v6 = vec_sel(v6,v8,vmask2);
+            v6 = vec_sel(v6,v9,vmask3);
+#else
+            v6 = vec_or(v6,v7);
+            v6 = vec_or(v6,v8);
+            v6 = vec_or(v6,v9);
+#endif
+            va = vec_nmsub(v6,vstep,va);
+            
+            vnoise1 = vec_madd(va,va,vnoise1);
+            
+            j += 4;
+        }
+        v1 = vec_sld(vnoise1,vnoise1,8);
+        v2 = vec_add(vnoise1,v1);
+        v3 = vec_sld(v2,v2,4);
+        v4 = vec_add(v2,v3);
+        v5 = vec_perm(v4,v4,vec_lvsr(0,&noise));
+        vec_ste(v5,0,&noise);
+        if(l) {
+            FLOAT   temp;
+            temp = fabs(cod_info->xr[j]) - pow43[ix[j]] * step;
+            j++;
+            noise += temp * temp;
+            temp = fabs(cod_info->xr[j]) - pow43[ix[j]] * step;
+            j++;
+            noise += temp * temp;
+        }
+#else
         while (l--) {
             FLOAT   temp;
             temp = fabs(cod_info->xr[j]) - pow43[ix[j]] * step;
@@ -789,6 +1005,7 @@
             j++;
             noise += temp * temp;
         }
+#endif
     }
 
     *startline = j;
